#!/usr/bin/env python

"""local alignment of 2 nucleotidic sequences"""
from __future__ import division


def local_alignment(subject_seq,oligo_seq):

    import numpy
       
    s2=oligo_seq
    s1=subject_seq

    output=[]

    matchW=10
    mismatchW=-9
    gapW=-20

    ni=len(s1)
    nj=len(s2)

    n=numpy.zeros((ni+1,nj+1), dtype=int)

    maxi=-10000

    for i in range(1,ni+1):
        for j in range(1,nj+1):
            if s1[i-1]==s2[j-1]:
                a=n[i-1,j-1]+matchW
            else:
                a=n[i-1,j-1]+mismatchW
            b=n[i,j-1]+gapW    
            c=n[i-1,j]+gapW
            n[i,j]=max(0,a,b,c)
                

    #screen matrix for all max scores
    maxi=n.max()
    print "maxi",maxi
    if maxi==0:
        print 'no hits'
        import sys
        sys.exit(1)


    for i2 in range(1,ni+1):
        for j2 in range(1,nj+1):
            if n[i2,j2]==maxi:
                #print 'maxi',i2,j2,maxi
                mi,mj=i2,j2
                #backtracking
                i,j=mi,mj
                 
                l1,l2=s1[i-1],s2[j-1]
                 
                while True:
                    #print i,j,l1,l2

                    a=n[i-1,j-1]
                    b=n[i,j-1]
                    c=n[i-1,j]


                    if (i==1 or j==1 or n[i,j]==0) or (a==0 and b==0 and c==0):
                        l1=''.join([c for c in reversed(l1)])
                        l2=''.join([c for c in reversed(l2)])
                        
                        
                        rd={}
                        #position of seq2 on seq1
    #                    output.append(i-j+1)  
                        rd['init_alignment'] = i-j+1
                        
                        #score
    #                    output.append(maxi/min(ni,nj)/matchW*100) 
                        rd['score'] = maxi / min(ni, nj) / matchW * 100
                        print "rd['score']",rd['score']
                        
                        #query seq
                        query_seq=(' '*(i-j)+s2[1-1:j-1]+l2+s2[mj+1-1:]).strip()
    #                    output.append(query_seq)
                        rd['aligned_query_seq'] = query_seq
                        
                        
                        dummy1 = ' '*(j-i)+s1[1-1:i-1]+l1+s1[mi+1-1:]
                        subject_seq = dummy1[i-j+1-1:i-j+1-1 + len(query_seq)]
    #                    output.append(dummy1[i-j+1-1:i-j+1-1 + len(query_seq)])
                        rd['aligned_subject_seq'] = subject_seq
                        
                        align_len = len(oligo_seq)
                        if oligo_seq.count('-'):
                            align_len = len(query_seq)
                        cc = subject_seq.count('-')
                        if cc:
                            align_len = len(subject_seq)-cc
                            
                        #end alignment position 
                        rd['end_alignment'] = rd['init_alignment'] + align_len-1

                        #match
                        match=''
                        print 'rd',rd
                        print 'query_seq:',query_seq
                        print 'subject_seq:',subject_seq
                        
                        for k in range(0,len(query_seq)):
                            print 'k:',k
                            if query_seq[k] == subject_seq[k]:
                                match+='|'
                            else:
                                match+=' '
                        rd['match']=match        
                                    
                        
                        output.append(rd)
                        
                        break #continue for loop

                    if (n[i,j]==n[i-1,j-1]+matchW and s1[i-1]==s2[j-1]) or (n[i,j]==n[i-1,j-1]+mismatchW and s1[i-1]<>s2[j-1]):
                        i=i-1
                        j=j-1
                        l1=l1+s1[i-1]
                        l2=l2+s2[j-1]
                        continue
                        
                    if n[i,j]==n[i,j-1]+gapW:
                        j=j-1
                        #insert('-',l1,length(l1));
                        l1=l1[0:-1]+'-'+l1[-1]
                        l2=l2+s2[j-1]
                        continue
                        
                    if n[i,j]==n[i-1,j]+gapW:
                        i=i-1
                        l1=l1+s1[i-1]
                        #insert('-',l2,length(l2));
                        l2=l2[0:-1]+'-'+l2[-1]
                        continue
                        
                    break
                    
    return output                                             
                     
                                      

