#!/usr/bin/env python

from PyQt4.QtGui import *
from seq_classes import *
import time

def loadProject(filename):
    """load pyannhyb or annhyb project file"""

    import xml.etree.ElementTree as ET
    try:
       tree=ET.parse(filename)
    except:
       print 'Wrong project file'
       return 'bad file',{}

    root = tree.getroot()
    id = 0
    itemList = {}
    
    for oligo in root.getiterator('oligo'):
        o = Oligo()
        o.name = oligo.findtext('oligo_name')
        o.seq = oligo.findtext('oligo_seq')
        o.salt_cc = float(oligo.findtext('oligo_salt_concentration'))
        o.oligo_cc = float(oligo.findtext('oligo_concentration'))
        o.notes = oligo.findtext('oligo_notes')
        itemList[id] = o
        id += 1

    for seq in root.getiterator('sequence'):
        s=Sequence()
        
        s.name=seq.findtext('sequence_name')
        #s.features=[]
        s.featuresDict={}
        s.longName = seq.findtext('sequence_longname')
        if not s.longName:
            s.longName = ''

        
        s.description = seq.findtext('sequence_description')
        if not s.description:
            s.description = ''


        s.type_ = seq.findtext('sequence_type')
        if not s.type_:
            s.type_ = ''

        s.author = seq.findtext('sequence_author')
        if not s.author:
            s.author = ''
        
        s.creation_date=seq.findtext('sequence_creation_date')
        if not s.creation_date:
            s.creation_date = ''
        
        s.header = seq.findtext('sequence_header')
        if not s.header:
            s.header = ''
        
        f_id = 0
        
        ### compatibility with AnnHyb project file
        if seq.findtext('sequence_features'):  #.annhyb features format
            print 'old features format found' 
            feat_list=seq.findtext('sequence_features').strip()
            if feat_list.find('feature ') == 0:  #old GCG features
                for feat in feat_list.split('\n'):
                    fs=feat.split(' ')
                    while '' in fs:
                        fs.remove('')
                    newFeature=Seq_Feat()
                    newFeature.begin=int(fs[1])
                    newFeature.end=int(fs[2])
                    
                    delphiColor=int(fs[3])
                    red = delphiColor & 0xff
                    green = (delphiColor & 0xff00) >> 8
                    blue = (delphiColor & 0xff0000) >> 16
                    
                    newFeature.color = (red,green,blue,255)  #alpha set to 255 (no transparency)
                    
                    newFeature.name=feat.split(' solid ')[1].split('///')[0].strip()
                    newFeature.comment=feat.split('///')[1].strip()
 
                    newFeature.parent_id = id #str to tuple
                    itemList[id*1000+f_id] =  newFeature
                    f_id += 1
 
        for feature in seq.getiterator('feature'):
            newFeature = Seq_Feat()
            newFeature.name = feature.findtext('name')
            newFeature.begin = int(feature.findtext('begin'))
            newFeature.end = int(feature.findtext('end'))
            newFeature.comment = feature.findtext('comment')
            newFeature.color = eval(feature.findtext('color')) #str to tuple
            
            newFeature.parent_id = id #str to tuple
            itemList[id*1000+f_id] =  newFeature
            f_id += 1
           
        s.seq = seq.findtext('sequence_seq')
        itemList[id] = s
        id+=1

    for ma in root.getiterator('multi-alignment'):
        m=MA()
        m.name=ma.findtext('ma_name')
        m.sequences_names=ma.findtext('ma_seq_name')
        m.sequences=ma.findtext('ma_seq_seq')
        itemList[id]=m
        id+=1

    print itemList

    return root.findtext("project/description"),itemList
